;;;*************************************************************************
;;;**  Demonstration Program for PIC mini Promer by Ulrich Hoffmann 1997
;;;**
;;;**  Make all Pins on Port A flash at exactly 1 hz (4 Mhz Osc freq)
;;;**
;;;**  This is public domain software
;;;**
;;;**  PIC16C84 8-bit CMOS single chip microcomputer
;;;**
;;;**  $Revision:   1.0  $
;;;*************************************************************************

        LIST P=16C84
        include "p16c84.inc"
        RADIX DEC

;;; -------------- Variables -----------------
ctr     EQU 12

;;; ----------------------------------------------------------------------------------
cycles  macro ticks             ; delay for exactly ticks cycles
        local loop,x,y
        ;;;  ticks = 4(x-1)+3+1+y  =>  x=(ticks/4), y=ticks-x*4
x=(ticks/4)
y=ticks-(x*4)

        if x>255
        error "cycles: Delay to long!"
        else
        if x>0
        movlw x                ;   1
loop    addlw -1               ;   1        4 cycles/loopiteration
        btfss STATUS,Z         ;   1 (2)
        goto loop              ;   2
        endif
        endif

        while y>0
        nop
y-=1
        endw
        endm


;;;--------------- Boot Code -----------------

        ORG 0
        goto Start

        ORG 4
        retfie            ; Interrupt

Start   call Init         ; initialize Hardware

        movlw H'01A'
        movwf PORTA

flash   ;; 500 ms cacle time
        ;; 2us + (1997us+3us)*248 + (1997us+2us) + 1996us+3us = 500.000us
        ;; pre      full loops       last loop       post
        movlw 249
        movwf ctr

wait    cycles 1000
        cycles  997

        decfsz ctr,f
        goto wait

        cycles 1000
        cycles  996

change  comf PORTA,f   ; complement port bits
        goto flash

Init    ;; initialize Hardware
        bsf STATUS,5         ; to page 1
        clrf TRISA & H'07F'  ; Port A as output
        movlw H'0FF'
        movwf TRISB & H'07F' ; Port B as input
        bcf STATUS,5         ; back to page 0
        clrf PORTA        ; reset all bits
        return

        END

